<template>
  <div class="models">
    <div class="models-content">
      <h3 class="models-title">Модели:</h3>
      <ul class="models-list">
        <li class="models-item" :class="{active:selectedType == index}" v-for="( type, index ) in models" :key="index">
          <button @click="clickType(index, type)">{{type.name}}</button>
          <ul class="submodels-list">
            <li class="submodels-item" :class="{active:selectedModel == model.id}" v-for="model in type.models" :key="model.id">
              <button @click="clickModel(model.id, model)">
                {{model.name}}
              </button>
              <ul class="subsubmodels-list">
                <li class="subsubmodels-item" :class="{active:selectedSubmodel == submodel.id}" v-for="submodel in model.sub_models" :key="submodel.id">
                  <button class="subsubmodels-button" @click="clickSubmodel(submodel.id, submodel)">
                    {{submodel.name}}
                  </button>
                </li>
              </ul>
            </li>
          </ul>
        </li>
      </ul>
      <Form/>
      <h3 class="models-title">Материалы:</h3>
      <Materials/>
    </div>
    <Info/>
    <router-link class="models-cart-link" to="/cart">В корзину</router-link>
  </div>
</template>
<script>
import { mapState, mapActions, mapMutations } from 'vuex'
import Materials from "./Materials.vue";
import Form from "./Form.vue";
import Info from "./Info.vue";

export default {
  name: 'Models',
  data() {
    return {
      selectedType: null,
      selectedModel: null,
      selectedSubmodel: null
    };
  },
  components: {
    Materials,
    Form,
    Info,
  },
  computed: mapState({
    models: state => state.models.models
  }),
  created() {
    this.getModels();
  },
  methods: {
    ...mapActions('models', [
      'getModels', 
      'getMaterials'
    ]),
    ...mapMutations('models', [
      'changeType',
      'changeModel',
      'changeSubmodel'
    ]),
    clickType(id, object) {
      this.selectedType = id;
      this.selectedModel = null;
      this.selectedSubmodel = null;
      this.changeType(object);
    },
    clickModel(id, object) {
      this.selectedModel = id;
      this.selectedSubmodel = null;
      this.getMaterials("https://test.customizer.amigo.ru/api/models/" + id + "/materials");
      this.changeModel(object);
      this.changeSubmodel(null);
    },
    clickSubmodel(id, object) {
      this.selectedSubmodel = id;
      this.getMaterials("https://test.customizer.amigo.ru/api/models/" + id + "/materials");
      this.changeSubmodel(object);
    }
  },
}
</script>
<style>
.models {
  display: flex;
  width: 100%;
  padding: 60px 20px 20px;
}
.models-content {
  flex: 1 1 50%;
}
.models-title {
  font-size: 40px;
  margin: 20px 0;
}
.models-list {
  display: block;
  width: 100%;
  max-width: 400px;
  margin: 0;
  padding: 0;
  list-style-type: none;
}
.models-item {
  margin: 0 0 8px;
}
.models-item:last-child {
  margin: 0;
}
.models-item button {
  display: block;
  width: 100%;
  font-size: 18px;
  line-height: 22px;
  text-align: left;
  color: #000;
  background-color: rgba(0, 0, 0, 0);
  border: none;
  padding: 0 20px 0 0;
  transition: 0.3s;
  position: relative;
  cursor: pointer;
}
.models-item:hover button, 
.models-item.active button {
  color: #539fbb;
}
.models-item button:after {
  content: "+";
  font-size: 22px;
  line-height: 22px;
  position: absolute;
  top: 0;
  left: auto;
  right: 0;
  transition: 0.3s;
}
.models-item.active:after {
  transform: rotate(45deg);
}
.submodels-list,
.subsubmodels-list {
  display: none;
  width: 100%;
  margin: 0;
  list-style-type: none;
}
.submodels-list {
  padding: 8px 0 0;
}
.subsubmodels-list {
  padding: 0;
}
.models-item.active .submodels-list,
.submodels-item.active .subsubmodels-list {
  display: block;
}
.models-item:hover .submodels-item button, 
.models-item.active .submodels-item button {
  color: #000;
}
.submodels-item button {
  display: block;
  width: 100%;
  font-size: 16px;
  padding: 4px 16px;
  cursor: pointer;
}
.submodels-item button:after {
  content: none;
}
.submodels-item:hover button, 
.submodels-item.active button {
  color: #fff;
  background-color: #000;
}
.models-item:hover .submodels-item:hover button, 
.models-item.active .submodels-item:hover button, 
.models-item:hover .submodels-item.active button, 
.models-item.active .submodels-item.active button {
  color: #fff;
}
.models-item .submodels-item .subsubmodels-item button.subsubmodels-button {
  font-size: 16px;
  color: #000;
  background-color: rgba(0, 0, 0, 0);
  padding: 8px 16px 8px 32px;
}
.models-item .submodels-item .subsubmodels-item:hover button.subsubmodels-button, 
.models-item .submodels-item .subsubmodels-item.active button.subsubmodels-button {
  color: #fff;
  background-color: #2c3e50;
  cursor: pointer;
}
.models-cart-link {
  position: absolute;
  top: 20px;
  left: auto;
  right: 20px;
  font-size: 16px;
  line-height: 20px;
  text-decoration: none;
  color: #000;
  transition: 0.3s;
  z-index: 1;
}
.models-cart-link:hover {
  color: #539fbb;
}
</style>